/*  Promile Qt - calculates amount of alcohol in your body
  *  Copyright (C) 2008  Marcin Dombrowski
  *
  *  This program is free software: you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation, either version 3 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "promile-qt.h"
#include <iostream>
#include "dop_stez.h"
extern Form ui;
extern int nr_napoju;
Form1::Form1(QWidget * parent, Qt::WFlags f):QDialog(parent, f)
{
 ui.setupUi(this);
 QTextCodec::setCodecForTr (QTextCodec::codecForName ("ISO8859-2"));

 connect(ui.pushButton_dodaj, SIGNAL(clicked()), this, SLOT(dodaj()));
 connect(ui.pushButton_oblicz, SIGNAL(clicked()), this, SLOT(oblicz()));
 connect(ui.pushButton_kasuj, SIGNAL(clicked()), this, SLOT(kasuj()));
 connect(ui.pushButton_wyb_czczionke, SIGNAL(clicked()), this, SLOT(czcionka_wynikow()));
 connect(ui.pushButton_wyb_czczionke_programu, SIGNAL(clicked()), this, SLOT(czcionka_programu()));
 connect(ui.comboBox_kraj, SIGNAL(currentIndexChanged(int)), this, SLOT(zmiana_kraju()));
 connect(ui.doubleSpinBox_dop_stez, SIGNAL(valueChanged(double)),this,SLOT(zmiana_dop_stez()));
}



void Form1::dodaj()
{
float cz_wchl = ui.spinBox_cz_wchl_godz->value()*60 + (ui.spinBox_cz_wchl_min->value()) ;
float cz_rozp = (ui.spinBox_czas_dzien->value()-1)*24.0*60 + ui.spinBox_czas_godz->value()*60 + (ui.spinBox_czas_min->value()); // czas rozpoczcia w godzinach
dodaj_napoj(ui.spinBox_ilosc->value(),cz_rozp,ui.doubleSpinBox_zawartosc->value(),cz_wchl,ui.spinBox_dl_pic->value());

// zwiększenie czasu rozpoczecia picia nastepnego napoju o czas picia poprzedniego
cz_rozp=cz_rozp+(ui.spinBox_dl_pic->value());
int cz_rozp_dzien = int (cz_rozp/(24.0*60));
int cz_rozp_godz = int ((cz_rozp - cz_rozp_dzien*24.0*60)/60.0);
int cz_rozp_min = int ((cz_rozp - 24.0*60*cz_rozp_dzien - cz_rozp_godz*60)+0.5);


//cz_rozp_min = cz_rozp_min - 60*cz_rozp_godz;
ui.spinBox_czas_godz->setValue(cz_rozp_godz);
ui.spinBox_czas_min->setValue(cz_rozp_min);
ui.spinBox_czas_dzien->setValue(cz_rozp_dzien+1);
};
//********************************************************************************
void Form1::kasuj()
{
ui.textBrowser_napoje->clear();
ui.textEdit->clear();
if (nr_napoju>1)
{
ui.spinBox_czas_godz->setValue(0);
ui.spinBox_czas_min->setValue(0);
ui.spinBox_czas_dzien->setValue(1);
}
kasuj_napoje();
}

void Form1::zmiana_kraju()
{
	disconnect(ui.doubleSpinBox_dop_stez, SIGNAL(valueChanged(double)),this,SLOT(zmiana_dop_stez()));
	ui.doubleSpinBox_dop_stez->setValue(dopuszczalna[ui.comboBox_kraj->currentIndex()]);
	connect(ui.doubleSpinBox_dop_stez, SIGNAL(valueChanged(double)),this,SLOT(zmiana_dop_stez()));
}

void Form1::zmiana_dop_stez()
{
	ui.comboBox_kraj->setCurrentIndex(0);
}

void Form1::czcionka_wynikow()
{
ui.textEdit->setFont(QFontDialog::getFont(0, ui.textEdit->currentFont()));
}

void Form1::czcionka_programu()
{
QFont font = QFontDialog::getFont(0,ui.pushButton_dodaj->font());
ui.groupBox_5->setFont(font);
ui.groupBox->setFont(font);
ui.radioButton_m->setFont(font);
ui.radioButton_k->setFont(font);
ui.label->setFont(font);
ui.spinBox_waga->setFont(font);
ui.groupBox_4->setFont(font);
ui.label_2->setFont(font);
ui.doubleSpinBox_prom_na_godz->setFont(font);
ui.groupBox_2->setFont(font);
ui.label_10->setFont(font);
ui.label_3->setFont(font);
ui.spinBox_ilosc->setFont(font);
ui.label_zawartosc->setFont(font);
ui.doubleSpinBox_zawartosc->setFont(font);
ui.label_7->setFont(font);
ui.spinBox_czas_godz->setFont(font);
ui.spinBox_czas_min->setFont(font);
ui.label_4->setFont(font);
ui.spinBox_dl_pic->setFont(font);
ui.groupBox_3->setFont(font);
ui.label_5->setFont(font);
ui.spinBox_cz_wchl_godz->setFont(font);
ui.spinBox_cz_wchl_min->setFont(font);
ui.pushButton_dodaj->setFont(font);
ui.pushButton_kasuj->setFont(font);
ui.pushButton_oblicz->setFont(font);
ui.tabWidget->setFont(font);
ui.label_6->setFont(font);
ui.spinBox_co_ile->setFont(font);
ui.textEdit->setFont(font);
ui.label_8->setFont(font);
ui.label_14->setFont(font);
ui.doubleSpinBox_dawka_smiertelna->setFont(font);
ui.spinBox_czas_dzien->setFont(font);
ui.label_15->setFont(font);
ui.label_16->setFont(font);
}

void Form1::oblicz()
{	char plec;
	ui.textEdit->clear();
	if (nr_napoju<=1)
	{
	kasuj();
	dodaj();
	
	ui.spinBox_czas_godz->setValue(0);
	ui.spinBox_czas_min->setValue(0);
	ui.spinBox_czas_dzien->setValue(1);
	}
	if (ui.radioButton_m->isChecked()) {plec='m';}
	else plec='k';
	glowna(plec, ui.spinBox_waga->value(),ui.spinBox_co_ile->value(),ui.doubleSpinBox_prom_na_godz->value()*ui.spinBox_waga->value());
}
